#!/bin/bash

command=$1; shift
domain=$1; shift
token=$1; shift
response=$1; shift

echo "command: $command"
echo "domain: $domain"
#echo "token: $token"
#echo "response: $response"

if [ "$command" == "deploy_challenge" ]; then
	cmd='tmsh modify ltm data-group internal acme_responses records add \{ "'$token'" \{ data "'$response'" \} \}'
	$cmd
fi

if [ "$command" == "clean_challenge" ]; then
	cmd='tmsh modify ltm data-group internal acme_responses records delete \{ "'$token'" \}'
	$cmd
fi

if [ "$command" == "deploy_cert" ]; then
	now=$(date +%Y-%m-%d)
	name=${domain}_${now}
	cert=${name}.crt
	key=${name}.key
	profile=auto_${domain}
	cp -f /root/certs/$domain/privkey.pem /config/ssl/ssl.key/$key
	cp -f /root/certs/$domain/fullchain.pem /config/ssl/ssl.crt/$cert
	tmsh install sys crypto key ${name} from-local-file /config/ssl/ssl.key/$key
	tmsh install sys crypt cert ${name} from-local-file /config/ssl/ssl.crt/$cert
	tmsh modify ltm profile client-ssl ${profile} cert-key-chain replace-all-with { default { key $key cert $cert } }
fi

